;;; This file was automatically generated by SWIG (http://www.swig.org).
;;; Version 1.3.40
;;;
;;; Do not make changes to this file unless you know what you are doing--modify
;;; the SWIG interface file instead.

(in-package :llvm)


(cffi:defctype uint8_t :unsigned-char)

;; A little hack make the Name argument for LLVMBuild* be optional and
;; default to the empty string.
(defmacro wrap-defcfun ((c-name lisp-name &rest options) return-type &body args)
  (if (and (eql (mismatch "LLVMBuild" c-name) 9)
                 (equal (last args) '((Name :string))))
      (let ((real-lisp-name (intern (concatenate 'string "%" (symbol-name lisp-name))
                                    (symbol-package lisp-name)))
            (mod-args (map 'list #'car (butlast args))))
        `(progn
           ( cffi:defcfun (,c-name ,real-lisp-name ,@options) ,return-type ,@args)
           (defmacro ,lisp-name (,@mod-args &optional (name ""))
             `(,',real-lisp-name ,,@mod-args ,name))))
      `( cffi:defcfun (,c-name ,lisp-name ,@options) ,return-type ,@args)))


(cffi:defctype LLVMBool :int)

(cffi:defctype LLVMContextRef :pointer)

(cffi:defctype LLVMModuleRef :pointer)

(cffi:defctype LLVMTypeRef :pointer)

(cffi:defctype LLVMTypeHandleRef :pointer)

(cffi:defctype LLVMValueRef :pointer)

(cffi:defctype LLVMBasicBlockRef :pointer)

(cffi:defctype LLVMBuilderRef :pointer)

(cffi:defctype LLVMModuleProviderRef :pointer)

(cffi:defctype LLVMMemoryBufferRef :pointer)

(cffi:defctype LLVMPassManagerRef :pointer)

(cffi:defctype LLVMUseIteratorRef :pointer)

(cffi:defbitfield LLVMAttribute
	(:LLVMZExtAttribute #.(cl:ash 1 0))
	(:LLVMSExtAttribute #.(cl:ash 1 1))
	(:LLVMNoReturnAttribute #.(cl:ash 1 2))
	(:LLVMInRegAttribute #.(cl:ash 1 3))
	(:LLVMStructRetAttribute #.(cl:ash 1 4))
	(:LLVMNoUnwindAttribute #.(cl:ash 1 5))
	(:LLVMNoAliasAttribute #.(cl:ash 1 6))
	(:LLVMByValAttribute #.(cl:ash 1 7))
	(:LLVMNestAttribute #.(cl:ash 1 8))
	(:LLVMReadNoneAttribute #.(cl:ash 1 9))
	(:LLVMReadOnlyAttribute #.(cl:ash 1 10))
	(:LLVMNoInlineAttribute #.(cl:ash 1 11))
	(:LLVMAlwaysInlineAttribute #.(cl:ash 1 12))
	(:LLVMOptimizeForSizeAttribute #.(cl:ash 1 13))
	(:LLVMStackProtectAttribute #.(cl:ash 1 14))
	(:LLVMStackProtectReqAttribute #.(cl:ash 1 15))
	(:LLVMNoCaptureAttribute #.(cl:ash 1 21))
	(:LLVMNoRedZoneAttribute #.(cl:ash 1 22))
	(:LLVMNoImplicitFloatAttribute #.(cl:ash 1 23))
	(:LLVMNakedAttribute #.(cl:ash 1 24))
	(:LLVMInlineHintAttribute #.(cl:ash 1 25)))

(cffi:defcenum LLVMOpcode
	(:LLVMRet #.1)
	(:LLVMBr #.2)
	(:LLVMSwitch #.3)
	(:LLVMInvoke #.4)
	(:LLVMUnwind #.5)
	(:LLVMUnreachable #.6)
	(:LLVMAdd #.7)
	(:LLVMFAdd #.8)
	(:LLVMSub #.9)
	(:LLVMFSub #.10)
	(:LLVMMul #.11)
	(:LLVMFMul #.12)
	(:LLVMUDiv #.13)
	(:LLVMSDiv #.14)
	(:LLVMFDiv #.15)
	(:LLVMURem #.16)
	(:LLVMSRem #.17)
	(:LLVMFRem #.18)
	(:LLVMShl #.19)
	(:LLVMLShr #.20)
	(:LLVMAShr #.21)
	(:LLVMAnd #.22)
	(:LLVMOr #.23)
	(:LLVMXor #.24)
	(:LLVMMalloc #.25)
	(:LLVMFree #.26)
	(:LLVMAlloca #.27)
	(:LLVMLoad #.28)
	(:LLVMStore #.29)
	(:LLVMGetElementPtr #.30)
	(:LLVMTrunk #.31)
	(:LLVMZExt #.32)
	(:LLVMSExt #.33)
	(:LLVMFPToUI #.34)
	(:LLVMFPToSI #.35)
	(:LLVMUIToFP #.36)
	(:LLVMSIToFP #.37)
	(:LLVMFPTrunc #.38)
	(:LLVMFPExt #.39)
	(:LLVMPtrToInt #.40)
	(:LLVMIntToPtr #.41)
	(:LLVMBitCast #.42)
	(:LLVMICmp #.43)
	(:LLVMFCmp #.44)
	(:LLVMPHI #.45)
	(:LLVMCall #.46)
	(:LLVMSelect #.47)
	(:LLVMVAArg #.50)
	(:LLVMExtractElement #.51)
	(:LLVMInsertElement #.52)
	(:LLVMShuffleVector #.53)
	(:LLVMExtractValue #.54)
	(:LLVMInsertValue #.55))

(cffi:defcenum LLVMTypeKind
	:LLVMVoidTypeKind
	:LLVMFloatTypeKind
	:LLVMDoubleTypeKind
	:LLVMX86_FP80TypeKind
	:LLVMFP128TypeKind
	:LLVMPPC_FP128TypeKind
	:LLVMLabelTypeKind
	:LLVMIntegerTypeKind
	:LLVMFunctionTypeKind
	:LLVMStructTypeKind
	:LLVMArrayTypeKind
	:LLVMPointerTypeKind
	:LLVMOpaqueTypeKind
	:LLVMVectorTypeKind
	:LLVMMetadataTypeKind)

(cffi:defcenum LLVMLinkage
	:LLVMExternalLinkage
	:LLVMAvailableExternallyLinkage
	:LLVMLinkOnceAnyLinkage
	:LLVMLinkOnceODRLinkage
	:LLVMWeakAnyLinkage
	:LLVMWeakODRLinkage
	:LLVMAppendingLinkage
	:LLVMInternalLinkage
	:LLVMPrivateLinkage
	:LLVMDLLImportLinkage
	:LLVMDLLExportLinkage
	:LLVMExternalWeakLinkage
	:LLVMGhostLinkage
	:LLVMCommonLinkage
	:LLVMLinkerPrivateLinkage)

(cffi:defcenum LLVMVisibility
	:LLVMDefaultVisibility
	:LLVMHiddenVisibility
	:LLVMProtectedVisibility)

(cffi:defcenum LLVMCallConv
	(:LLVMCCallConv #.0)
	(:LLVMFastCallConv #.8)
	(:LLVMColdCallConv #.9)
	(:LLVMX86StdcallCallConv #.64)
	(:LLVMX86FastcallCallConv #.65))

(cffi:defcenum LLVMIntPredicate
	(:LLVMIntEQ #.32)
	:LLVMIntNE
	:LLVMIntUGT
	:LLVMIntUGE
	:LLVMIntULT
	:LLVMIntULE
	:LLVMIntSGT
	:LLVMIntSGE
	:LLVMIntSLT
	:LLVMIntSLE)

(cffi:defcenum LLVMRealPredicate
	:LLVMRealPredicateFalse
	:LLVMRealOEQ
	:LLVMRealOGT
	:LLVMRealOGE
	:LLVMRealOLT
	:LLVMRealOLE
	:LLVMRealONE
	:LLVMRealORD
	:LLVMRealUNO
	:LLVMRealUEQ
	:LLVMRealUGT
	:LLVMRealUGE
	:LLVMRealULT
	:LLVMRealULE
	:LLVMRealUNE
	:LLVMRealPredicateTrue)

(wrap-defcfun ("LLVMDisposeMessage" LLVMDisposeMessage) :void
  (Message :string))

(wrap-defcfun ("LLVMContextCreate" LLVMContextCreate) LLVMContextRef)

(wrap-defcfun ("LLVMGetGlobalContext" LLVMGetGlobalContext) LLVMContextRef)

(wrap-defcfun ("LLVMContextDispose" LLVMContextDispose) :void
  (C LLVMContextRef))

(wrap-defcfun ("LLVMModuleCreateWithNameInContext" %LLVMModuleCreateWithNameInContext) LLVMModuleRef
  (ModuleID :string)
  (C LLVMContextRef))

(wrap-defcfun ("LLVMDisposeModule" LLVMDisposeModule) :void
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMGetDataLayout" LLVMGetDataLayout) :string
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMSetDataLayout" LLVMSetDataLayout) :void
  (M LLVMModuleRef)
  (Triple :string))

(wrap-defcfun ("LLVMGetTarget" LLVMGetTarget) :string
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMSetTarget" LLVMSetTarget) :void
  (M LLVMModuleRef)
  (Triple :string))

(wrap-defcfun ("LLVMAddTypeName" LLVMAddTypeName) :boolean
  (M LLVMModuleRef)
  (Name :string)
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMDeleteTypeName" LLVMDeleteTypeName) :void
  (M LLVMModuleRef)
  (Name :string))

(wrap-defcfun ("LLVMGetTypeByName" LLVMGetTypeByName) LLVMTypeRef
  (M LLVMModuleRef)
  (Name :string))

(wrap-defcfun ("LLVMDumpModule" LLVMDumpModule) :void
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMGetTypeKind" LLVMGetTypeKind) LLVMTypeKind
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMGetTypeContext" LLVMGetTypeContext) LLVMContextRef
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMInt1TypeInContext" %LLVMInt1TypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMInt8TypeInContext" %LLVMInt8TypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMInt16TypeInContext" %LLVMInt16TypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMInt32TypeInContext" %LLVMInt32TypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMInt64TypeInContext" %LLVMInt64TypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMIntTypeInContext" %LLVMIntTypeInContext) LLVMTypeRef
  (C LLVMContextRef)
  (NumBits :unsigned-int))

(wrap-defcfun ("LLVMGetIntTypeWidth" LLVMGetIntTypeWidth) :unsigned-int
  (IntegerTy LLVMTypeRef))

(wrap-defcfun ("LLVMFloatTypeInContext" %LLVMFloatTypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMDoubleTypeInContext" %LLVMDoubleTypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMX86FP80TypeInContext" %LLVMX86FP80TypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMFP128TypeInContext" %LLVMFP128TypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMPPCFP128TypeInContext" %LLVMPPCFP128TypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMFunctionType" %LLVMFunctionType) LLVMTypeRef
  (ReturnType LLVMTypeRef)
  (ParamTypes :pointer)
  (ParamCount :unsigned-int)
  (IsVarArg :boolean))

(wrap-defcfun ("LLVMIsFunctionVarArg" LLVMIsFunctionVarArg) :boolean
  (FunctionTy LLVMTypeRef))

(wrap-defcfun ("LLVMGetReturnType" LLVMGetReturnType) LLVMTypeRef
  (FunctionTy LLVMTypeRef))

(wrap-defcfun ("LLVMCountParamTypes" LLVMCountParamTypes) :unsigned-int
  (FunctionTy LLVMTypeRef))

(wrap-defcfun ("LLVMGetParamTypes" %LLVMGetParamTypes) :void
  (FunctionTy LLVMTypeRef)
  (Dest :pointer))

(wrap-defcfun ("LLVMStructTypeInContext" %LLVMStructTypeInContext) LLVMTypeRef
  (C LLVMContextRef)
  (ElementTypes :pointer)
  (ElementCount :unsigned-int)
  (Packed :boolean))

(wrap-defcfun ("LLVMCountStructElementTypes" LLVMCountStructElementTypes) :unsigned-int
  (StructTy LLVMTypeRef))

(wrap-defcfun ("LLVMGetStructElementTypes" %LLVMGetStructElementTypes) :void
  (StructTy LLVMTypeRef)
  (Dest :pointer))

(wrap-defcfun ("LLVMIsPackedStruct" LLVMIsPackedStruct) :boolean
  (StructTy LLVMTypeRef))

(wrap-defcfun ("LLVMArrayType" LLVMArrayType) LLVMTypeRef
  (ElementType LLVMTypeRef)
  (ElementCount :unsigned-int))

(wrap-defcfun ("LLVMPointerType" LLVMPointerType) LLVMTypeRef
  (ElementType LLVMTypeRef)
  (AddressSpace :unsigned-int))

(wrap-defcfun ("LLVMVectorType" LLVMVectorType) LLVMTypeRef
  (ElementType LLVMTypeRef)
  (ElementCount :unsigned-int))

(wrap-defcfun ("LLVMGetElementType" LLVMGetElementType) LLVMTypeRef
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMGetArrayLength" LLVMGetArrayLength) :unsigned-int
  (ArrayTy LLVMTypeRef))

(wrap-defcfun ("LLVMGetPointerAddressSpace" LLVMGetPointerAddressSpace) :unsigned-int
  (PointerTy LLVMTypeRef))

(wrap-defcfun ("LLVMGetVectorSize" LLVMGetVectorSize) :unsigned-int
  (VectorTy LLVMTypeRef))

(wrap-defcfun ("LLVMVoidTypeInContext" %LLVMVoidTypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMLabelTypeInContext" %LLVMLabelTypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMOpaqueTypeInContext" %LLVMOpaqueTypeInContext) LLVMTypeRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMCreateTypeHandle" LLVMCreateTypeHandle) LLVMTypeHandleRef
  (PotentiallyAbstractTy LLVMTypeRef))

(wrap-defcfun ("LLVMRefineType" LLVMRefineType) :void
  (AbstractTy LLVMTypeRef)
  (ConcreteTy LLVMTypeRef))

(wrap-defcfun ("LLVMResolveTypeHandle" LLVMResolveTypeHandle) LLVMTypeRef
  (TypeHandle LLVMTypeHandleRef))

(wrap-defcfun ("LLVMDisposeTypeHandle" LLVMDisposeTypeHandle) :void
  (TypeHandle LLVMTypeHandleRef))

(wrap-defcfun ("LLVMTypeOf" LLVMTypeOf) LLVMTypeRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMGetValueName" LLVMGetValueName) :string
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMSetValueName" LLVMSetValueName) :void
  (Val LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMDumpValue" LLVMDumpValue) :void
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMReplaceAllUsesWith" LLVMReplaceAllUsesWith) :void
  (OldVal LLVMValueRef)
  (NewVal LLVMValueRef))

(wrap-defcfun ("LLVMIsAArgument" LLVMIsAArgument) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsABasicBlock" LLVMIsABasicBlock) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAInlineAsm" LLVMIsAInlineAsm) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAUser" LLVMIsAUser) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstant" LLVMIsAConstant) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstantAggregateZero" LLVMIsAConstantAggregateZero) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstantArray" LLVMIsAConstantArray) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstantExpr" LLVMIsAConstantExpr) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstantFP" LLVMIsAConstantFP) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstantInt" LLVMIsAConstantInt) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstantPointerNull" LLVMIsAConstantPointerNull) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstantStruct" LLVMIsAConstantStruct) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAConstantVector" LLVMIsAConstantVector) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAGlobalValue" LLVMIsAGlobalValue) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAFunction" LLVMIsAFunction) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAGlobalAlias" LLVMIsAGlobalAlias) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAGlobalVariable" LLVMIsAGlobalVariable) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAUndefValue" LLVMIsAUndefValue) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAInstruction" LLVMIsAInstruction) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsABinaryOperator" LLVMIsABinaryOperator) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsACallInst" LLVMIsACallInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAIntrinsicInst" LLVMIsAIntrinsicInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsADbgInfoIntrinsic" LLVMIsADbgInfoIntrinsic) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsADbgDeclareInst" LLVMIsADbgDeclareInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsADbgFuncStartInst" LLVMIsADbgFuncStartInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsADbgRegionEndInst" LLVMIsADbgRegionEndInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsADbgRegionStartInst" LLVMIsADbgRegionStartInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsADbgStopPointInst" LLVMIsADbgStopPointInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAEHSelectorInst" LLVMIsAEHSelectorInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAMemIntrinsic" LLVMIsAMemIntrinsic) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAMemCpyInst" LLVMIsAMemCpyInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAMemMoveInst" LLVMIsAMemMoveInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAMemSetInst" LLVMIsAMemSetInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsACmpInst" LLVMIsACmpInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAFCmpInst" LLVMIsAFCmpInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAICmpInst" LLVMIsAICmpInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAExtractElementInst" LLVMIsAExtractElementInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAGetElementPtrInst" LLVMIsAGetElementPtrInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAInsertElementInst" LLVMIsAInsertElementInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAInsertValueInst" LLVMIsAInsertValueInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAPHINode" LLVMIsAPHINode) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsASelectInst" LLVMIsASelectInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAShuffleVectorInst" LLVMIsAShuffleVectorInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAStoreInst" LLVMIsAStoreInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsATerminatorInst" LLVMIsATerminatorInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsABranchInst" LLVMIsABranchInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAInvokeInst" LLVMIsAInvokeInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAReturnInst" LLVMIsAReturnInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsASwitchInst" LLVMIsASwitchInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAUnreachableInst" LLVMIsAUnreachableInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAUnwindInst" LLVMIsAUnwindInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAUnaryInstruction" LLVMIsAUnaryInstruction) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAAllocaInst" LLVMIsAAllocaInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsACastInst" LLVMIsACastInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsABitCastInst" LLVMIsABitCastInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAFPExtInst" LLVMIsAFPExtInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAFPToSIInst" LLVMIsAFPToSIInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAFPToUIInst" LLVMIsAFPToUIInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAFPTruncInst" LLVMIsAFPTruncInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAIntToPtrInst" LLVMIsAIntToPtrInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAPtrToIntInst" LLVMIsAPtrToIntInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsASExtInst" LLVMIsASExtInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsASIToFPInst" LLVMIsASIToFPInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsATruncInst" LLVMIsATruncInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAUIToFPInst" LLVMIsAUIToFPInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAZExtInst" LLVMIsAZExtInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAExtractValueInst" LLVMIsAExtractValueInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsALoadInst" LLVMIsALoadInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsAVAArgInst" LLVMIsAVAArgInst) LLVMValueRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMGetFirstUse" LLVMGetFirstUse) LLVMUseIteratorRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMGetNextUse" LLVMGetNextUse) LLVMUseIteratorRef
  (U LLVMUseIteratorRef))

(wrap-defcfun ("LLVMGetUser" LLVMGetUser) LLVMValueRef
  (U LLVMUseIteratorRef))

(wrap-defcfun ("LLVMGetUsedValue" LLVMGetUsedValue) LLVMValueRef
  (U LLVMUseIteratorRef))

(wrap-defcfun ("LLVMGetOperand" LLVMGetOperand) LLVMValueRef
  (Val LLVMValueRef)
  (Index :unsigned-int))

(wrap-defcfun ("LLVMConstNull" LLVMConstNull) LLVMValueRef
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMConstAllOnes" LLVMConstAllOnes) LLVMValueRef
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMGetUndef" LLVMGetUndef) LLVMValueRef
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMIsConstant" LLVMIsConstant) :boolean
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsNull" LLVMIsNull) :boolean
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMIsUndef" LLVMIsUndef) :boolean
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMConstPointerNull" LLVMConstPointerNull) LLVMValueRef
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMConstInt" %LLVMConstInt) LLVMValueRef
  (IntTy LLVMTypeRef)
  (N :unsigned-long-long)
  (SignExtend :boolean))

(wrap-defcfun ("LLVMConstIntOfString" LLVMConstIntOfString) LLVMValueRef
  (IntTy LLVMTypeRef)
  (Text :string)
  (Radix :unsigned-char))

(wrap-defcfun ("LLVMConstIntOfStringAndSize" LLVMConstIntOfStringAndSize) LLVMValueRef
  (IntTy LLVMTypeRef)
  (Text :string)
  (SLen :unsigned-int)
  (Radix :unsigned-char))

(wrap-defcfun ("LLVMConstReal" LLVMConstReal) LLVMValueRef
  (RealTy LLVMTypeRef)
  (N :double))

(wrap-defcfun ("LLVMConstRealOfString" LLVMConstRealOfString) LLVMValueRef
  (RealTy LLVMTypeRef)
  (Text :string))

(wrap-defcfun ("LLVMConstRealOfStringAndSize" LLVMConstRealOfStringAndSize) LLVMValueRef
  (RealTy LLVMTypeRef)
  (Text :string)
  (SLen :unsigned-int))

(wrap-defcfun ("LLVMConstIntGetZExtValue" LLVMConstIntGetZExtValue) :unsigned-long-long
  (ConstantVal LLVMValueRef))

(wrap-defcfun ("LLVMConstIntGetSExtValue" LLVMConstIntGetSExtValue) :long-long
  (ConstantVal LLVMValueRef))

(wrap-defcfun ("LLVMConstStringInContext" %LLVMConstStringInContext) LLVMValueRef
  (C LLVMContextRef)
  (Str :string)
  (Length :unsigned-int)
  (DontNullTerminate :boolean))

(wrap-defcfun ("LLVMConstStructInContext" %LLVMConstStructInContext) LLVMValueRef
  (C LLVMContextRef)
  (ConstantVals :pointer)
  (Count :unsigned-int)
  (Packed :boolean))

(wrap-defcfun ("LLVMConstArray" %LLVMConstArray) LLVMValueRef
  (ElementTy LLVMTypeRef)
  (ConstantVals :pointer)
  (Length :unsigned-int))

(wrap-defcfun ("LLVMConstVector" %LLVMConstVector) LLVMValueRef
  (ScalarConstantVals :pointer)
  (Size :unsigned-int))

(wrap-defcfun ("LLVMGetConstOpcode" LLVMGetConstOpcode) LLVMOpcode
  (ConstantVal LLVMValueRef))

(wrap-defcfun ("LLVMAlignOf" LLVMAlignOf) LLVMValueRef
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMSizeOf" LLVMSizeOf) LLVMValueRef
  (Ty LLVMTypeRef))

(wrap-defcfun ("LLVMConstNeg" LLVMConstNeg) LLVMValueRef
  (ConstantVal LLVMValueRef))

(wrap-defcfun ("LLVMConstFNeg" LLVMConstFNeg) LLVMValueRef
  (ConstantVal LLVMValueRef))

(wrap-defcfun ("LLVMConstNot" LLVMConstNot) LLVMValueRef
  (ConstantVal LLVMValueRef))

(wrap-defcfun ("LLVMConstAdd" LLVMConstAdd) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstNSWAdd" LLVMConstNSWAdd) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstFAdd" LLVMConstFAdd) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstSub" LLVMConstSub) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstFSub" LLVMConstFSub) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstMul" LLVMConstMul) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstFMul" LLVMConstFMul) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstUDiv" LLVMConstUDiv) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstSDiv" LLVMConstSDiv) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstExactSDiv" LLVMConstExactSDiv) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstFDiv" LLVMConstFDiv) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstURem" LLVMConstURem) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstSRem" LLVMConstSRem) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstFRem" LLVMConstFRem) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstAnd" LLVMConstAnd) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstOr" LLVMConstOr) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstXor" LLVMConstXor) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstICmp" LLVMConstICmp) LLVMValueRef
  (Predicate LLVMIntPredicate)
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstFCmp" LLVMConstFCmp) LLVMValueRef
  (Predicate LLVMRealPredicate)
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstShl" LLVMConstShl) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstLShr" LLVMConstLShr) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstAShr" LLVMConstAShr) LLVMValueRef
  (LHSConstant LLVMValueRef)
  (RHSConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstGEP" %LLVMConstGEP) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ConstantIndices :pointer)
  (NumIndices :unsigned-int))

(wrap-defcfun ("LLVMConstInBoundsGEP" %LLVMConstInBoundsGEP) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ConstantIndices :pointer)
  (NumIndices :unsigned-int))

(wrap-defcfun ("LLVMConstTrunc" LLVMConstTrunc) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstSExt" LLVMConstSExt) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstZExt" LLVMConstZExt) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstFPTrunc" LLVMConstFPTrunc) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstFPExt" LLVMConstFPExt) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstUIToFP" LLVMConstUIToFP) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstSIToFP" LLVMConstSIToFP) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstFPToUI" LLVMConstFPToUI) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstFPToSI" LLVMConstFPToSI) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstPtrToInt" LLVMConstPtrToInt) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstIntToPtr" LLVMConstIntToPtr) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstBitCast" LLVMConstBitCast) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstZExtOrBitCast" LLVMConstZExtOrBitCast) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstSExtOrBitCast" LLVMConstSExtOrBitCast) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstTruncOrBitCast" LLVMConstTruncOrBitCast) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstPointerCast" LLVMConstPointerCast) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstIntCast" LLVMConstIntCast) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef)
  (isSigned :boolean))

(wrap-defcfun ("LLVMConstFPCast" LLVMConstFPCast) LLVMValueRef
  (ConstantVal LLVMValueRef)
  (ToType LLVMTypeRef))

(wrap-defcfun ("LLVMConstSelect" LLVMConstSelect) LLVMValueRef
  (ConstantCondition LLVMValueRef)
  (ConstantIfTrue LLVMValueRef)
  (ConstantIfFalse LLVMValueRef))

(wrap-defcfun ("LLVMConstExtractElement" LLVMConstExtractElement) LLVMValueRef
  (VectorConstant LLVMValueRef)
  (IndexConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstInsertElement" LLVMConstInsertElement) LLVMValueRef
  (VectorConstant LLVMValueRef)
  (ElementValueConstant LLVMValueRef)
  (IndexConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstShuffleVector" LLVMConstShuffleVector) LLVMValueRef
  (VectorAConstant LLVMValueRef)
  (VectorBConstant LLVMValueRef)
  (MaskConstant LLVMValueRef))

(wrap-defcfun ("LLVMConstExtractValue" %LLVMConstExtractValue) LLVMValueRef
  (AggConstant LLVMValueRef)
  (IdxList :pointer)
  (NumIdx :unsigned-int))

(wrap-defcfun ("LLVMConstInsertValue" %LLVMConstInsertValue) LLVMValueRef
  (AggConstant LLVMValueRef)
  (ElementValueConstant LLVMValueRef)
  (IdxList :pointer)
  (NumIdx :unsigned-int))

(wrap-defcfun ("LLVMConstInlineAsm" LLVMConstInlineAsm) LLVMValueRef
  (Ty LLVMTypeRef)
  (AsmString :string)
  (Constraints :string)
  (HasSideEffects :boolean)
  (IsAlignStack :boolean))

(wrap-defcfun ("LLVMGetGlobalParent" LLVMGetGlobalParent) LLVMModuleRef
  (Global LLVMValueRef))

(wrap-defcfun ("LLVMIsDeclaration" LLVMIsDeclaration) :boolean
  (Global LLVMValueRef))

(wrap-defcfun ("LLVMGetLinkage" LLVMGetLinkage) LLVMLinkage
  (Global LLVMValueRef))

(wrap-defcfun ("LLVMSetLinkage" LLVMSetLinkage) :void
  (Global LLVMValueRef)
  (Linkage LLVMLinkage))

(wrap-defcfun ("LLVMGetSection" LLVMGetSection) :string
  (Global LLVMValueRef))

(wrap-defcfun ("LLVMSetSection" LLVMSetSection) :void
  (Global LLVMValueRef)
  (Section :string))

(wrap-defcfun ("LLVMGetVisibility" LLVMGetVisibility) LLVMVisibility
  (Global LLVMValueRef))

(wrap-defcfun ("LLVMSetVisibility" LLVMSetVisibility) :void
  (Global LLVMValueRef)
  (Viz LLVMVisibility))

(wrap-defcfun ("LLVMGetAlignment" LLVMGetAlignment) :unsigned-int
  (Global LLVMValueRef))

(wrap-defcfun ("LLVMSetAlignment" LLVMSetAlignment) :void
  (Global LLVMValueRef)
  (Bytes :unsigned-int))

(wrap-defcfun ("LLVMAddGlobal" LLVMAddGlobal) LLVMValueRef
  (M LLVMModuleRef)
  (Ty LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMGetNamedGlobal" LLVMGetNamedGlobal) LLVMValueRef
  (M LLVMModuleRef)
  (Name :string))

(wrap-defcfun ("LLVMGetFirstGlobal" LLVMGetFirstGlobal) LLVMValueRef
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMGetLastGlobal" LLVMGetLastGlobal) LLVMValueRef
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMGetNextGlobal" LLVMGetNextGlobal) LLVMValueRef
  (GlobalVar LLVMValueRef))

(wrap-defcfun ("LLVMGetPreviousGlobal" LLVMGetPreviousGlobal) LLVMValueRef
  (GlobalVar LLVMValueRef))

(wrap-defcfun ("LLVMDeleteGlobal" LLVMDeleteGlobal) :void
  (GlobalVar LLVMValueRef))

(wrap-defcfun ("LLVMGetInitializer" LLVMGetInitializer) LLVMValueRef
  (GlobalVar LLVMValueRef))

(wrap-defcfun ("LLVMSetInitializer" LLVMSetInitializer) :void
  (GlobalVar LLVMValueRef)
  (ConstantVal LLVMValueRef))

(wrap-defcfun ("LLVMIsThreadLocal" LLVMIsThreadLocal) :boolean
  (GlobalVar LLVMValueRef))

(wrap-defcfun ("LLVMSetThreadLocal" LLVMSetThreadLocal) :void
  (GlobalVar LLVMValueRef)
  (IsThreadLocal :boolean))

(wrap-defcfun ("LLVMIsGlobalConstant" LLVMIsGlobalConstant) :boolean
  (GlobalVar LLVMValueRef))

(wrap-defcfun ("LLVMSetGlobalConstant" LLVMSetGlobalConstant) :void
  (GlobalVar LLVMValueRef)
  (IsConstant :boolean))

(wrap-defcfun ("LLVMAddAlias" LLVMAddAlias) LLVMValueRef
  (M LLVMModuleRef)
  (Ty LLVMTypeRef)
  (Aliasee LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMAddFunction" LLVMAddFunction) LLVMValueRef
  (M LLVMModuleRef)
  (Name :string)
  (FunctionTy LLVMTypeRef))

(wrap-defcfun ("LLVMGetNamedFunction" LLVMGetNamedFunction) LLVMValueRef
  (M LLVMModuleRef)
  (Name :string))

(wrap-defcfun ("LLVMGetFirstFunction" LLVMGetFirstFunction) LLVMValueRef
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMGetLastFunction" LLVMGetLastFunction) LLVMValueRef
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMGetNextFunction" LLVMGetNextFunction) LLVMValueRef
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetPreviousFunction" LLVMGetPreviousFunction) LLVMValueRef
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMDeleteFunction" LLVMDeleteFunction) :void
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetIntrinsicID" LLVMGetIntrinsicID) :unsigned-int
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetFunctionCallConv" LLVMGetFunctionCallConv) :unsigned-int
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMSetFunctionCallConv" LLVMSetFunctionCallConv) :void
  (Fn LLVMValueRef)
  (CC :unsigned-int))

(wrap-defcfun ("LLVMGetGC" LLVMGetGC) :string
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMSetGC" LLVMSetGC) :void
  (Fn LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMGetFunctionAttr" LLVMGetFunctionAttr) LLVMAttribute
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMCountParams" LLVMCountParams) :unsigned-int
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetParams" %LLVMGetParams) :void
  (Fn LLVMValueRef)
  (Params :pointer))

(wrap-defcfun ("LLVMGetParam" LLVMGetParam) LLVMValueRef
  (Fn LLVMValueRef)
  (Index :unsigned-int))

(wrap-defcfun ("LLVMGetParamParent" LLVMGetParamParent) LLVMValueRef
  (Inst LLVMValueRef))

(wrap-defcfun ("LLVMGetFirstParam" LLVMGetFirstParam) LLVMValueRef
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetLastParam" LLVMGetLastParam) LLVMValueRef
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetNextParam" LLVMGetNextParam) LLVMValueRef
  (Arg LLVMValueRef))

(wrap-defcfun ("LLVMGetPreviousParam" LLVMGetPreviousParam) LLVMValueRef
  (Arg LLVMValueRef))

(wrap-defcfun ("LLVMAddAttribute" LLVMAddAttribute) :void
  (Arg LLVMValueRef)
  (PA LLVMAttribute))

(wrap-defcfun ("LLVMRemoveAttribute" LLVMRemoveAttribute) :void
  (Arg LLVMValueRef)
  (PA LLVMAttribute))

(wrap-defcfun ("LLVMGetAttribute" LLVMGetAttribute) LLVMAttribute
  (Arg LLVMValueRef))

(wrap-defcfun ("LLVMSetParamAlignment" LLVMSetParamAlignment) :void
  (Arg LLVMValueRef)
  (align :unsigned-int))

(wrap-defcfun ("LLVMBasicBlockAsValue" LLVMBasicBlockAsValue) LLVMValueRef
  (BB LLVMBasicBlockRef))

(wrap-defcfun ("LLVMValueIsBasicBlock" LLVMValueIsBasicBlock) :boolean
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMValueAsBasicBlock" LLVMValueAsBasicBlock) LLVMBasicBlockRef
  (Val LLVMValueRef))

(wrap-defcfun ("LLVMGetBasicBlockParent" LLVMGetBasicBlockParent) LLVMValueRef
  (BB LLVMBasicBlockRef))

(wrap-defcfun ("LLVMCountBasicBlocks" LLVMCountBasicBlocks) :unsigned-int
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetBasicBlocks" LLVMGetBasicBlocks) :void
  (Fn LLVMValueRef)
  (BasicBlocks :pointer))

(wrap-defcfun ("LLVMGetFirstBasicBlock" LLVMGetFirstBasicBlock) LLVMBasicBlockRef
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetLastBasicBlock" LLVMGetLastBasicBlock) LLVMBasicBlockRef
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMGetNextBasicBlock" LLVMGetNextBasicBlock) LLVMBasicBlockRef
  (BB LLVMBasicBlockRef))

(wrap-defcfun ("LLVMGetPreviousBasicBlock" LLVMGetPreviousBasicBlock) LLVMBasicBlockRef
  (BB LLVMBasicBlockRef))

(wrap-defcfun ("LLVMGetEntryBasicBlock" LLVMGetEntryBasicBlock) LLVMBasicBlockRef
  (Fn LLVMValueRef))

(wrap-defcfun ("LLVMAppendBasicBlockInContext" %LLVMAppendBasicBlockInContext) LLVMBasicBlockRef
  (C LLVMContextRef)
  (Fn LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMInsertBasicBlockInContext" %LLVMInsertBasicBlockInContext) LLVMBasicBlockRef
  (C LLVMContextRef)
  (BB LLVMBasicBlockRef)
  (Name :string))

(wrap-defcfun ("LLVMDeleteBasicBlock" LLVMDeleteBasicBlock) :void
  (BB LLVMBasicBlockRef))

(wrap-defcfun ("LLVMGetInstructionParent" LLVMGetInstructionParent) LLVMBasicBlockRef
  (Inst LLVMValueRef))

(wrap-defcfun ("LLVMGetFirstInstruction" LLVMGetFirstInstruction) LLVMValueRef
  (BB LLVMBasicBlockRef))

(wrap-defcfun ("LLVMGetLastInstruction" LLVMGetLastInstruction) LLVMValueRef
  (BB LLVMBasicBlockRef))

(wrap-defcfun ("LLVMGetNextInstruction" LLVMGetNextInstruction) LLVMValueRef
  (Inst LLVMValueRef))

(wrap-defcfun ("LLVMGetPreviousInstruction" LLVMGetPreviousInstruction) LLVMValueRef
  (Inst LLVMValueRef))

(wrap-defcfun ("LLVMSetInstructionCallConv" LLVMSetInstructionCallConv) :void
  (Instr LLVMValueRef)
  (CC :unsigned-int))

(wrap-defcfun ("LLVMGetInstructionCallConv" LLVMGetInstructionCallConv) :unsigned-int
  (Instr LLVMValueRef))

(wrap-defcfun ("LLVMAddInstrAttribute" LLVMAddInstrAttribute) :void
  (Instr LLVMValueRef)
  (index :unsigned-int)
  (arg2 LLVMAttribute))

(wrap-defcfun ("LLVMRemoveInstrAttribute" LLVMRemoveInstrAttribute) :void
  (Instr LLVMValueRef)
  (index :unsigned-int)
  (arg2 LLVMAttribute))

(wrap-defcfun ("LLVMSetInstrParamAlignment" LLVMSetInstrParamAlignment) :void
  (Instr LLVMValueRef)
  (index :unsigned-int)
  (align :unsigned-int))

(wrap-defcfun ("LLVMIsTailCall" LLVMIsTailCall) :boolean
  (CallInst LLVMValueRef))

(wrap-defcfun ("LLVMSetTailCall" LLVMSetTailCall) :void
  (CallInst LLVMValueRef)
  (IsTailCall :boolean))

(wrap-defcfun ("LLVMAddIncoming" %LLVMAddIncoming) :void
  (PhiNode LLVMValueRef)
  (IncomingValues :pointer)
  (IncomingBlocks :pointer)
  (Count :unsigned-int))

(wrap-defcfun ("LLVMCountIncoming" LLVMCountIncoming) :unsigned-int
  (PhiNode LLVMValueRef))

(wrap-defcfun ("LLVMGetIncomingValue" LLVMGetIncomingValue) LLVMValueRef
  (PhiNode LLVMValueRef)
  (Index :unsigned-int))

(wrap-defcfun ("LLVMGetIncomingBlock" LLVMGetIncomingBlock) LLVMBasicBlockRef
  (PhiNode LLVMValueRef)
  (Index :unsigned-int))

(wrap-defcfun ("LLVMCreateBuilderInContext" %LLVMCreateBuilderInContext) LLVMBuilderRef
  (C LLVMContextRef))

(wrap-defcfun ("LLVMPositionBuilder" LLVMPositionBuilder) :void
  (Builder LLVMBuilderRef)
  (Block LLVMBasicBlockRef)
  (Instr LLVMValueRef))

(wrap-defcfun ("LLVMPositionBuilderBefore" LLVMPositionBuilderBefore) :void
  (Builder LLVMBuilderRef)
  (Instr LLVMValueRef))

(wrap-defcfun ("LLVMPositionBuilderAtEnd" LLVMPositionBuilderAtEnd) :void
  (Builder LLVMBuilderRef)
  (Block LLVMBasicBlockRef))

(wrap-defcfun ("LLVMGetInsertBlock" LLVMGetInsertBlock) LLVMBasicBlockRef
  (Builder LLVMBuilderRef))

(wrap-defcfun ("LLVMClearInsertionPosition" LLVMClearInsertionPosition) :void
  (Builder LLVMBuilderRef))

(wrap-defcfun ("LLVMInsertIntoBuilder" LLVMInsertIntoBuilder) :void
  (Builder LLVMBuilderRef)
  (Instr LLVMValueRef))

(wrap-defcfun ("LLVMInsertIntoBuilderWithName" LLVMInsertIntoBuilderWithName) :void
  (Builder LLVMBuilderRef)
  (Instr LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMDisposeBuilder" LLVMDisposeBuilder) :void
  (Builder LLVMBuilderRef))

(wrap-defcfun ("LLVMBuildRetVoid" LLVMBuildRetVoid) LLVMValueRef
  (arg0 LLVMBuilderRef))

(wrap-defcfun ("LLVMBuildRet" LLVMBuildRet) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (V LLVMValueRef))

(wrap-defcfun ("LLVMBuildAggregateRet" %LLVMBuildAggregateRet) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (RetVals :pointer)
  (N :unsigned-int))

(wrap-defcfun ("LLVMBuildBr" LLVMBuildBr) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Dest LLVMBasicBlockRef))

(wrap-defcfun ("LLVMBuildCondBr" LLVMBuildCondBr) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (If LLVMValueRef)
  (Then LLVMBasicBlockRef)
  (Else LLVMBasicBlockRef))

(wrap-defcfun ("LLVMBuildSwitch" LLVMBuildSwitch) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (V LLVMValueRef)
  (Else LLVMBasicBlockRef)
  (NumCases :unsigned-int))

(wrap-defcfun ("LLVMBuildInvoke" %LLVMBuildInvoke) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Fn LLVMValueRef)
  (Args :pointer)
  (NumArgs :unsigned-int)
  (Then LLVMBasicBlockRef)
  (Catch LLVMBasicBlockRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildUnwind" LLVMBuildUnwind) LLVMValueRef
  (arg0 LLVMBuilderRef))

(wrap-defcfun ("LLVMBuildUnreachable" LLVMBuildUnreachable) LLVMValueRef
  (arg0 LLVMBuilderRef))

(wrap-defcfun ("LLVMAddCase" LLVMAddCase) :void
  (Switch LLVMValueRef)
  (OnVal LLVMValueRef)
  (Dest LLVMBasicBlockRef))

(wrap-defcfun ("LLVMBuildAdd" LLVMBuildAdd) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildNSWAdd" LLVMBuildNSWAdd) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFAdd" LLVMBuildFAdd) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildSub" LLVMBuildSub) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFSub" LLVMBuildFSub) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildMul" LLVMBuildMul) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFMul" LLVMBuildFMul) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildUDiv" LLVMBuildUDiv) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildSDiv" LLVMBuildSDiv) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildExactSDiv" LLVMBuildExactSDiv) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFDiv" LLVMBuildFDiv) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildURem" LLVMBuildURem) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildSRem" LLVMBuildSRem) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFRem" LLVMBuildFRem) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildShl" LLVMBuildShl) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildLShr" LLVMBuildLShr) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildAShr" LLVMBuildAShr) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildAnd" LLVMBuildAnd) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildOr" LLVMBuildOr) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildXor" LLVMBuildXor) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildNeg" LLVMBuildNeg) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (V LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFNeg" LLVMBuildFNeg) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (V LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildNot" LLVMBuildNot) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (V LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildMalloc" LLVMBuildMalloc) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Ty LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildArrayMalloc" LLVMBuildArrayMalloc) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Ty LLVMTypeRef)
  (Val LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildAlloca" LLVMBuildAlloca) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Ty LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildArrayAlloca" LLVMBuildArrayAlloca) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Ty LLVMTypeRef)
  (Val LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFree" LLVMBuildFree) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (PointerVal LLVMValueRef))

(wrap-defcfun ("LLVMBuildLoad" LLVMBuildLoad) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (PointerVal LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildStore" LLVMBuildStore) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (Ptr LLVMValueRef))

(wrap-defcfun ("LLVMBuildGEP" %LLVMBuildGEP) LLVMValueRef
  (B LLVMBuilderRef)
  (Pointer LLVMValueRef)
  (Indices :pointer)
  (NumIndices :unsigned-int)
  (Name :string))

(wrap-defcfun ("LLVMBuildInBoundsGEP" %LLVMBuildInBoundsGEP) LLVMValueRef
  (B LLVMBuilderRef)
  (Pointer LLVMValueRef)
  (Indices :pointer)
  (NumIndices :unsigned-int)
  (Name :string))

(wrap-defcfun ("LLVMBuildStructGEP" LLVMBuildStructGEP) LLVMValueRef
  (B LLVMBuilderRef)
  (Pointer LLVMValueRef)
  (Idx :unsigned-int)
  (Name :string))

(wrap-defcfun ("LLVMBuildGlobalString" LLVMBuildGlobalString) LLVMValueRef
  (B LLVMBuilderRef)
  (Str :string)
  (Name :string))

(wrap-defcfun ("LLVMBuildGlobalStringPtr" LLVMBuildGlobalStringPtr) LLVMValueRef
  (B LLVMBuilderRef)
  (Str :string)
  (Name :string))

(wrap-defcfun ("LLVMBuildTrunc" LLVMBuildTrunc) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildZExt" LLVMBuildZExt) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildSExt" LLVMBuildSExt) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFPToUI" LLVMBuildFPToUI) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFPToSI" LLVMBuildFPToSI) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildUIToFP" LLVMBuildUIToFP) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildSIToFP" LLVMBuildSIToFP) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFPTrunc" LLVMBuildFPTrunc) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFPExt" LLVMBuildFPExt) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildPtrToInt" LLVMBuildPtrToInt) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildIntToPtr" LLVMBuildIntToPtr) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildBitCast" LLVMBuildBitCast) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildZExtOrBitCast" LLVMBuildZExtOrBitCast) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildSExtOrBitCast" LLVMBuildSExtOrBitCast) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildTruncOrBitCast" LLVMBuildTruncOrBitCast) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildPointerCast" LLVMBuildPointerCast) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildIntCast" LLVMBuildIntCast) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFPCast" LLVMBuildFPCast) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (DestTy LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildICmp" LLVMBuildICmp) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Op LLVMIntPredicate)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildFCmp" LLVMBuildFCmp) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Op LLVMRealPredicate)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildPhi" LLVMBuildPhi) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Ty LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildCall" %LLVMBuildCall) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Fn LLVMValueRef)
  (Args :pointer)
  (NumArgs :unsigned-int)
  (Name :string))

(wrap-defcfun ("LLVMBuildSelect" LLVMBuildSelect) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (If LLVMValueRef)
  (Then LLVMValueRef)
  (Else LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildVAArg" LLVMBuildVAArg) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (List LLVMValueRef)
  (Ty LLVMTypeRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildExtractElement" LLVMBuildExtractElement) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (VecVal LLVMValueRef)
  (Index LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildInsertElement" LLVMBuildInsertElement) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (VecVal LLVMValueRef)
  (EltVal LLVMValueRef)
  (Index LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildShuffleVector" LLVMBuildShuffleVector) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (V1 LLVMValueRef)
  (V2 LLVMValueRef)
  (Mask LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildExtractValue" LLVMBuildExtractValue) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (AggVal LLVMValueRef)
  (Index :unsigned-int)
  (Name :string))

(wrap-defcfun ("LLVMBuildInsertValue" LLVMBuildInsertValue) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (AggVal LLVMValueRef)
  (EltVal LLVMValueRef)
  (Index :unsigned-int)
  (Name :string))

(wrap-defcfun ("LLVMBuildIsNull" LLVMBuildIsNull) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildIsNotNull" LLVMBuildIsNotNull) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (Val LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMBuildPtrDiff" LLVMBuildPtrDiff) LLVMValueRef
  (arg0 LLVMBuilderRef)
  (LHS LLVMValueRef)
  (RHS LLVMValueRef)
  (Name :string))

(wrap-defcfun ("LLVMCreateModuleProviderForExistingModule" LLVMCreateModuleProviderForExistingModule) LLVMModuleProviderRef
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMDisposeModuleProvider" LLVMDisposeModuleProvider) :void
  (MP LLVMModuleProviderRef))

(wrap-defcfun ("LLVMCreateMemoryBufferWithContentsOfFile" LLVMCreateMemoryBufferWithContentsOfFile) :boolean
  (Path :string)
  (OutMemBuf :pointer)
  (OutMessage :pointer))

(wrap-defcfun ("LLVMCreateMemoryBufferWithSTDIN" LLVMCreateMemoryBufferWithSTDIN) :boolean
  (OutMemBuf :pointer)
  (OutMessage :pointer))

(wrap-defcfun ("LLVMDisposeMemoryBuffer" LLVMDisposeMemoryBuffer) :void
  (MemBuf LLVMMemoryBufferRef))

(wrap-defcfun ("LLVMCreatePassManager" LLVMCreatePassManager) LLVMPassManagerRef)

(wrap-defcfun ("LLVMCreateFunctionPassManager" LLVMCreateFunctionPassManager) LLVMPassManagerRef
  (MP LLVMModuleProviderRef))

(wrap-defcfun ("LLVMRunPassManager" LLVMRunPassManager) :boolean
  (PM LLVMPassManagerRef)
  (M LLVMModuleRef))

(wrap-defcfun ("LLVMInitializeFunctionPassManager" LLVMInitializeFunctionPassManager) :boolean
  (FPM LLVMPassManagerRef))

(wrap-defcfun ("LLVMRunFunctionPassManager" LLVMRunFunctionPassManager) :boolean
  (FPM LLVMPassManagerRef)
  (F LLVMValueRef))

(wrap-defcfun ("LLVMFinalizeFunctionPassManager" LLVMFinalizeFunctionPassManager) :boolean
  (FPM LLVMPassManagerRef))

(wrap-defcfun ("LLVMDisposePassManager" LLVMDisposePassManager) :void
  (PM LLVMPassManagerRef))

;;; The wrappers to expose the "InContext" versions of the functions
;;; in a more lispy way.
(declaim (special *llvm-context*))

(defun LLVMModuleCreateWithName (ModuleId &optional (context *llvm-context*))
  (%LLVMModuleCreateWithNameInContext ModuleId context))

(defun LLVMInt1Type (&optional (context *llvm-context*))
  (%LLVMInt1TypeInContext context))

(defun LLVMInt8Type (&optional (context *llvm-context*))
  (%LLVMInt8TypeInContext context))

(defun LLVMInt16Type (&optional (context *llvm-context*))
  (%LLVMInt16TypeInContext context))

(defun LLVMInt32Type (&optional (context *llvm-context*))
  (%LLVMInt32TypeInContext context))

(defun LLVMInt64Type (&optional (context *llvm-context*))
  (%LLVMInt64TypeInContext context))

(defun LLVMIntType (NumBits &optional (context *llvm-context*))
  (%LLVMIntTypeInContext context NumBits))

(defun LLVMFloatType (&optional (context *llvm-context*))
  (%LLVMFloatTypeInContext context))

(defun LLVMDoubleType (&optional (context *llvm-context*))
  (%LLVMDoubleTypeInContext context))

(defun LLVMX86FP80Type (&optional (context *llvm-context*))
  (%LLVMX86FP80TypeInContext context))

(defun LLVMFP128Type (&optional (context *llvm-context*))
  (%LLVMFP128TypeInContext context))

(defun LLVMPPCFP128Type (&optional (context *llvm-context*))
  (%LLVMPPCFP128TypeInContext context))

;; LLVMStructTypeInContext handled below.

(defun LLVMVoidType (&optional (context *llvm-context*))
  (%LLVMVoidTypeInContext context))

(defun LLVMLabelType (&optional (context *llvm-context*))
  (%LLVMLabelTypeInContext context))

(defun LLVMOpaqueType (&optional (context *llvm-context*))
  (%LLVMOpaqueTypeInContext context))

;; LLVMConstStringInContext handled below
;; LLVMConstStructInContext handled below

(defun LLVMAppendBasicBlock (Fn Name &optional (context *llvm-context*))
  (%LLVMAppendBasicBlockInContext context Fn Name))

(defun LLVMInsertBasicBlock (BB Name &optional (context *llvm-context*))
  (%LLVMInsertBasicBlockInContext context BB Name))

(defun LLVMCreateBuilder (&optional (context *llvm-context*))
  (%LLVMCreateBuilderInContext context))


;; More complex wrappers for dealing with pointers.

(defmacro with-array-and-length ((array len list) &body body)
  (let ((list-v (gensym "list")))
    `(let* ((,list-v ,list)
            (,len (length ,list-v)))
       (cffi:with-foreign-object (,array :pointer ,len)
         (loop for l in ,list-v
               for i from 0
               do
               (setf (cffi:mem-aref ,array :pointer i) l))
         (progn ,@body)))))

(defun LLVMFunctionType (ret params is-var-arg)
  "Combines the C API's ParamTypes array and ParamCount arguments into
a single list PARAMS."
  (with-array-and-length (array len params)
    (%LLVMFunctionType ret array len is-var-arg)))

(defun LLVMGetParamTypes (function-type)
  "Returns a list of param types rather than filling out a Dest pointer argument"
  (let ((len (LLVMCountParamTypes function-type)))
    (cffi:with-foreign-object (array :pointer len)
      (%LLVMGetParamTypes function-type array)
      (loop for i from 0 below len
            collect
            (cffi:mem-aref array :pointer i)))))

(defun LLVMStructType (element-types is-packed &optional (context *llvm-context*))
  (with-array-and-length (array len element-types)
    (%LLVMStructTypeInContext context array len is-packed)))

(defun LLVMGetStructElementTypes (struct-type)
  "Returns a list of param types rather than filling out a Dest pointer argument"
  (let ((len (LLVMCountStructElementTypes struct-type)))
    (cffi:with-foreign-object (array :pointer len)
      (%LLVMGetStructElementTypes struct-type array)
      (loop for i from 0 below len
            collect
            (cffi:mem-aref array :pointer i)))))

(defun LLVMConstString (str dont-null-terminate &optional (context *llvm-context*))
  (cffi:with-foreign-string ((foreign-string num-bytes) str)
    (%LLVMConstStringInContext context foreign-string num-bytes dont-null-terminate)))

(defun LLVMConstStruct (vals packed-p &optional (context *llvm-context*))
  (with-array-and-length (array len vals)
    (%LLVMConstStructInContext context array len packed-p)))

(defun LLVMConstArray (type vals)
  (with-array-and-length (array len vals)
    (%LLVMConstArray type array len)))

(defun LLVMConstVector (vals)
  (with-array-and-length (array len vals)
    (%LLVMConstVector array len)))

(defun LLVMConstGEP (ptr indices)
 (with-array-and-length (array len indices)
   (%LLVMConstGEP ptr array len)))

(defun LLVMConstInBoundsGEP (ptr indices)
 (with-array-and-length (array len indices)
   (%LLVMConstInBoundsGEP ptr array len)))

(defun LLVMConstExtractValue (AggConstant indices)
 (with-array-and-length (array len indices)
   (%LLVMConstExtractValue AggConstant array len)))

(defun LLVMConstInsertValue (AggConstant ValConstant indices)
 (with-array-and-length (array len indices)
   (%LLVMConstInsertValue AggConstant ValConstant array len)))

(defun LLVMGetParams (fn)
  "Returns a list of params rather than filling out a Dest pointer argument."
  (let ((len (LLVMCountParams fn)))
    (cffi:with-foreign-object (array :pointer len)
      (%LLVMGetParams fn array)
      (loop for i from 0 below len
            collect
            (cffi:mem-aref array :pointer i)))))

(defun LLVMAddIncoming (phi-node incoming-val incoming-block)
  "Unlike the C API (but like the C++ API...), takes only a single
incoming val and incoming block. Call multiple times if you want to
add multiple incoming values."
  (cffi:with-foreign-objects ((incoming-vals :pointer)
                              (incoming-blocks :pointer))
    (setf (cffi:mem-aref incoming-vals :pointer 0) incoming-val)
    (setf (cffi:mem-aref incoming-blocks :pointer 0) incoming-block)
    (%LLVMAddIncoming phi-node incoming-vals incoming-blocks 1)))

(defun LLVMBuildAggregateRet (builder vals)
 (with-array-and-length (array len vals)
   (%LLVMBuildAggregateRet builder array len)))

(defun LLVMBuildInvoke (builder fn args then catch &optional (name ""))
  (with-array-and-length (array len args)
    (%LLVMBuildInvoke builder fn array len then catch name)))

(defun LLVMBuildGEP (builder ptr indices &optional (name ""))
  (with-array-and-length (array len indices)
    (%LLVMBuildGEP builder ptr array len name)))

(defun LLVMBuildInBoundsGEP (builder ptr indices &optional (name ""))
  (with-array-and-length (array len indices)
    (%LLVMBuildInBoundsGEP builder ptr array len name)))

(defun LLVMBuildCall (builder fn args &optional (name ""))
  "Combines the C API's Args array and NumArgs arguments into a single
list ARGS."
  (with-array-and-length (array len args)
    (%LLVMBuildCall builder fn array len name)))

;; TODO:
;; LLVMCreateMemoryBufferWithContentsOfFile has OutMemBuf, OutMessage
;; LLVMCreateMemoryBufferWithSTDIN has OutMemBuf, OutMessage



